const Me           = imports.misc.extensionUtils.getCurrentExtension();
const Overview     = imports.ui.main.overview;
const ViewSelector = imports.ui.main.overview._viewSelector;
const Workspaces   = imports.ui.main.overview._viewSelector._workspacesDisplay._controls;

const Apps  = Me.imports.apps;
const Prefs = Me.imports.prefs;

let showWorkspaces = true;
let applications   = {};
let workspaces     = {};
let search         = {};
let undos          = [];

function init() {
    function toggle(page) {
        function toggle() {
            showWorkspaces = false;
            Overview.toggle();
            return Overview.visible;
        }

        return function() {
            if (Overview.visible && ViewSelector._searchCancelled != page || toggle()) {
                ViewSelector._searchCancelled = page;
                ViewSelector.reset();
                page();
            }
        };
    }

    workspaces = {
        toggle : toggle(function() {
            ViewSelector._activePage = ViewSelector._searchPage;
            ViewSelector._showPage(ViewSelector._workspacesPage);
            Workspaces.show(true);
        })
    };
    search = {
        toggle : toggle(function() {
            ViewSelector._searchResults.reset();
            ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
    applications = {
        toggle : toggle(function() {
            ViewSelector._searchResults.doSearch(Apps.SEARCH_CATEGORY);
            ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
}

function enable() {
    function reallyShowOverview() {
        return !Overview._modal;
    }

    function reallyShowWorkspaces() {
        return showWorkspaces;
    }

    let clear = let (
        searchCancelled = ViewSelector._searchCancelled
    ) function() {
        ViewSelector._searchCancelled = searchCancelled;
        ViewSelector.reset();
        showWorkspaces = true;
    };

    undos.push(
        clear,
        Prefs.override(Overview, 'show', reallyShowOverview),
        Prefs.override(Workspaces, 'show', reallyShowWorkspaces),
        Prefs.connect(Overview, 'hiding', clear),
        Prefs.connect(ViewSelector._showAppsButton, 'notify::checked', clear)
    );
}

function disable() {
    while(undos.length > 0) {
        undos.pop()();
    }
}
